/*
 * Encender y apagar LED desde el navegador
 * Versión de texto
 * xsetaseta@gmail.com
 * http://seta43.blogspot.com/
 */

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>

#ifndef STASSID
#define STASSID "router"
#define STAPSK  "contraseña"
#endif



#define LED_D0 16
#define LED_D1 5
#define LED_D2 4
#define LED_D3 0

const char* ssid = STASSID;
const char* password = STAPSK;

IPAddress ip(192,168,1,200);     
IPAddress gateway(192,168,1,1);   
IPAddress subnet(255,255,255,0); 

ESP8266WebServer server(80);


#define MAXmibuffer2  2000
char mibuffer2[MAXmibuffer2 + 1];  //ajustar al tamaÃ±o de la

bool F_led0;
bool F_led1;
bool F_led2;
bool F_led3;


static const char  Iniciohtml[] = "<!DOCTYPE HTML>\r\n <html><TITLE>SERVER WEB NodeMCU - ESP8266 </TITLE>  \
  <button type=\"button\" onclick=\"location.href='./'\"  style=\"height:100px;width:200px \"><h2>ACTUALIZAR</h2> </button> <b>Seta43_ESP8266_NodeMCU </b> <hr> \      
  ";
static const char  Finhtml[] = " <hr> xsetaseta@gmail.com </html>";
static const char  Cuerpo0html[] = " \
<br><button type=\"button\" onclick=\"location.href='./led0_on'\"  style=\"background-color:red; color:#A9F5A9;height:100px;width:200px \"><h2>ENCENDER_D0</h2> </button>  \      
<button type=\"button\" onclick=\"location.href='./led0_off'\"  style=\"background-color:green; color:#A9F5A9;height:100px;width:200px \"><h2>APAGAR_D0</h2> </button>";
static const char  Cuerpo1html[] = " \
<br><button type=\"button\" onclick=\"location.href='./led1_on'\"  style=\"background-color:red; color:#A9F5A9;height:100px;width:200px \"><h2>ENCENDER_D1</h2> </button>  \      
<button type=\"button\" onclick=\"location.href='./led1_off'\"  style=\"background-color:green; color:#A9F5A9;height:100px;width:200px \"><h2>APAGAR_D1</h2> </button>";
static const char  Cuerpo2html[] = " \
<br><button type=\"button\" onclick=\"location.href='./led2_on'\"  style=\"background-color:red; color:#A9F5A9;height:100px;width:200px \"><h2>ENCENDER_D2</h2> </button>  \      
<button type=\"button\" onclick=\"location.href='./led2_off'\"  style=\"background-color:green; color:#A9F5A9;height:100px;width:200px \"><h2>APAGAR_D2</h2> </button>";
static const char  Cuerpo3html[] = " \
<br><button type=\"button\" onclick=\"location.href='./led3_on'\"  style=\"background-color:red; color:#A9F5A9;height:100px;width:200px \"><h2>ENCENDER_D3</h2> </button>  \      
<button type=\"button\" onclick=\"location.href='./led3_off'\"  style=\"background-color:green; color:#A9F5A9;height:100px;width:200px \"><h2>APAGAR_D3</h2> </button>";


void handleRoot()
{
  int z;
  strcpy(mibuffer2, Iniciohtml);


 strcat(mibuffer2, Cuerpo0html);
  if (F_led0 == 1)
    strcat(mibuffer2, "<button type=\"button\"   style=\"background-color:red; height:60px;width:60px \"> D0</button> ");
  else
    strcat(mibuffer2, "<button type=\"button\"   style=\" height:60px;width:60px \"> D0</button> ");


  strcat(mibuffer2, Cuerpo1html);  
  if (F_led1 == 1)
    strcat(mibuffer2, "<button type=\"button\"   style=\"background-color:red; height:60px;width:60px \"> D1</button> ");
  else
    strcat(mibuffer2, "<button type=\"button\"   style=\" height:60px;width:60px \"> D1</button> ");


  strcat(mibuffer2, Cuerpo2html); 
  if (F_led2 == 1)
    strcat(mibuffer2, "<button type=\"button\"   style=\"background-color:red; height:60px;width:60px \"> D2</button> ");
  else
    strcat(mibuffer2, "<button type=\"button\"   style=\" height:60px;width:60px \"> D2</button> ");

  strcat(mibuffer2, Cuerpo3html); 
  if (F_led3 == 1)
    strcat(mibuffer2, "<button type=\"button\"   style=\"background-color:red; height:60px;width:60px \"> D3</button> ");
  else
    strcat(mibuffer2, "<button type=\"button\"   style=\" height:60px;width:60px \"> D3</button> ");

  strcat(mibuffer2, Finhtml);
  z = strlen(mibuffer2);
//  Serial.print("Tamano=");
//  Serial.println(z);
  server.send(z, "text/html", mibuffer2 );
}

void f_led0_off()  {  F_led0 = 0;  handleRoot();  digitalWrite(LED_D0, LOW); }
void f_led0_on()  {  F_led0 = 1;  handleRoot();  digitalWrite(LED_D0, HIGH);}

void f_led1_off()  {  F_led1 = 0;  handleRoot();  digitalWrite(LED_D1, LOW); }
void f_led1_on()  {  F_led1 = 1;  handleRoot();  digitalWrite(LED_D1, HIGH);}

void f_led2_off()  {  F_led2 = 0;  handleRoot();  digitalWrite(LED_D2, LOW); }
void f_led2_on()  {  F_led2 = 1;  handleRoot();  digitalWrite(LED_D2, HIGH);}

void f_led3_off()  {  F_led3 = 0;  handleRoot();  digitalWrite(LED_D3, LOW); }
void f_led3_on()  {  F_led3 = 1;  handleRoot();  digitalWrite(LED_D3, HIGH);}    



void handleNotFound()
{
  String message = "File Not Found\n\n";
  server.send(404, "text/plain", message);
}

void setup(void) {

  pinMode(LED_D0, OUTPUT);
  pinMode(LED_D1, OUTPUT);
  pinMode(LED_D2, OUTPUT);
  pinMode(LED_D3, OUTPUT);

  digitalWrite(LED_D0, LOW);
  digitalWrite(LED_D1, LOW);
  digitalWrite(LED_D2, LOW);
  digitalWrite(LED_D3, LOW);
  

  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  WiFi.config(ip, gateway, subnet);
  WiFi.begin(ssid, password);
  Serial.println("COMIENZA");


  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) 
  {
    delay(500);
    Serial.print(".");
  }
  
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  if (MDNS.begin("esp8266")) {
    Serial.println("MDNS responder started");
  }

  server.on("/", handleRoot);
  server.on("/led0_on", f_led0_on);
  server.on("/led0_off", f_led0_off);

  server.on("/led1_on", f_led1_on);
  server.on("/led1_off", f_led1_off);

  server.on("/led2_on", f_led2_on);
  server.on("/led2_off", f_led2_off);

  server.on("/led3_on", f_led3_on);
  server.on("/led3_off", f_led3_off);

  server.on("/ok", []() {    server.send(200, "text/plain", "TRABAJA BIEN");  });

  server.onNotFound(handleNotFound);

  server.begin();
  Serial.println("HTTP server started");
}

void loop(void) 
{
  server.handleClient();
  MDNS.update();
}
